import { useEffect, useMemo, useRef, useState } from 'react';
import { CellContext } from '@tanstack/react-table';
import { useSearchParams } from 'next/navigation';
import useSWR from 'swr';
import { useFormik } from 'formik';

import Button from '@/components/Button';
import Card from '@/components/Card';
import DateInput from '@/components/input/DateInput';
import DebouncedTextInput from '@/components/input/DebouncedTextInput';
import SelectInput, {
  OptionType,
  useSelect,
} from '@/components/input/SelectInput';
import Table from '@/components/Table';
import { formatCurrency, formatDate, formatTitleCase } from '@/lib/helper';
import { useTableFilter } from '@/services/hooks/useTableFilter';
import { Finance } from '@/types/api/finance/finance';
import {
  FINANCE_INITIAL_BALANCE_STATUS,
  FINANCE_INJECTION_STATUS,
  FINANCE_TRANSACTION_STATUS,
  FINANCE_TRANSACTION_TYPE_OPTIONS,
} from '@/config/constant';
import { FinanceApi } from '@/services/api/finance';
import { isResponseSuccess } from '@/lib/api-helper';
import { BankApi, CustomerApi, SupplierApi } from '@/services/api/master-data';
import { Bank } from '@/types/api/master-data/bank';
import { useModal } from '@/components/Modal';
import ConfirmationModal from '@/components/modal/ConfirmationModal';
import toast from 'react-hot-toast';
import RowOptionsMenuWrapper from '@/components/table/RowOptionsMenuWrapper';
import RequirePermission from '@/components/helper/RequirePermission';
import { Icon } from '@iconify/react';
import RowDropdownOptions from '@/components/table/RowDropdownOptions';
import RowCollapseOptions from '@/components/table/RowCollapseOptions';
import { useUiStore } from '@/stores/ui/ui.store';
import {
  FinanceTableFilterSchema,
  FinanceTableFilterValues,
} from './FinanceTableFilter.schema';

const RowOptionsMenu = ({
  type = 'dropdown',
  props,
  deleteClickHandler,
}: {
  type: 'dropdown' | 'collapse';
  props: CellContext<Finance, unknown>;
  deleteClickHandler: () => void;
}) => {
  return (
    <RowOptionsMenuWrapper type={type}>
      <RequirePermission
        permissions={[
          'lti.finance.transactions.detail',
          'lti.finance.initial_balances.detail',
          'lti.finance.injections.detail',
          'lti.finance.payments.detail',
        ]}
      >
        <Button
          href={`/finance/detail?financeId=${props.row.original.id}`}
          variant='ghost'
          color='primary'
          className='justify-start text-sm'
        >
          <Icon icon='mdi:eye-outline' width={16} height={16} />
          Detail
        </Button>
      </RequirePermission>

      {FINANCE_TRANSACTION_STATUS.includes(
        props.row.original.transaction_type
      ) && (
        <RequirePermission permissions='lti.finance.payments.update'>
          <Button
            href={`/finance/detail/edit?financeId=${props.row.original.id}`}
            variant='ghost'
            color='warning'
            className='justify-start text-sm'
          >
            <Icon icon='material-symbols:edit-outline' width={16} height={16} />
            Edit
          </Button>
        </RequirePermission>
      )}

      {FINANCE_INITIAL_BALANCE_STATUS.includes(
        props.row.original.transaction_type
      ) && (
        <RequirePermission permissions='lti.finance.initial_balances.update'>
          <Button
            href={`/finance/detail/edit/initial-balance?financeId=${props.row.original.id}`}
            variant='ghost'
            color='warning'
            className='justify-start text-sm'
          >
            <Icon icon='material-symbols:edit-outline' width={16} height={16} />
            Edit
          </Button>
        </RequirePermission>
      )}

      {FINANCE_INJECTION_STATUS.includes(
        props.row.original.transaction_type
      ) && (
        <RequirePermission permissions='lti.finance.injections.update'>
          <Button
            href={`/finance/detail/edit/injection?financeId=${props.row.original.id}`}
            variant='ghost'
            color='warning'
            className='justify-start text-sm'
          >
            <Icon icon='material-symbols:edit-outline' width={16} height={16} />
            Edit
          </Button>
        </RequirePermission>
      )}

      <RequirePermission permissions='lti.finance.transactions.delete'>
        <Button
          onClick={deleteClickHandler}
          variant='ghost'
          color='error'
          className='text-error hover:text-inherit'
        >
          <Icon
            icon='material-symbols:delete-outline-rounded'
            width={16}
            height={16}
            className='justify-start text-sm'
          />
          Delete
        </Button>
      </RequirePermission>
    </RowOptionsMenuWrapper>
  );
};

const FinanceTable = () => {
  const { searchValue, setSearchValue, resetSearchValue } = useUiStore();
  const previousPathRef = useRef<string | null>(null);

  const {
    state: tableFilterState,
    updateFilter,
    setPage,
    setPageSize,
    toQueryString: getTableFilterQueryString,
  } = useTableFilter({
    initial: {
      search: searchValue,
      transactionTypes: '',
      bankIds: '',
      customerIds: '',
      supplierIds: '',
      sortBy: '',
      startDate: '',
      endDate: '',
    },
    paramMap: {
      page: 'page',
      pageSize: 'limit',
      transactionTypes: 'transaction_types',
      bankIds: 'bank_ids',
      customerIds: 'customer_ids',
      supplierIds: 'supplier_ids',
      sortBy: 'sort_date',
      startDate: 'start_date',
      endDate: 'end_date',
    },
  });

  // ===== State =====
  const deleteModal = useModal();
  const [selectedTransactionType, setSelectedTransactionType] = useState<
    OptionType | OptionType[] | null
  >(null);
  const [selectedBank, setSelectedBank] = useState<
    OptionType | OptionType[] | null
  >(null);
  const [selectedCustomerId, setSelectedCustomerId] = useState<
    OptionType | OptionType[] | null
  >(null);
  const [selectedSupplierId, setSelectedSupplierId] = useState<
    OptionType | OptionType[] | null
  >(null);
  const [selectedSortBy, setSelectedSortBy] = useState<OptionType | null>(null);
  const [selectedFinance, setSelectedFinance] = useState<Finance | null>(null);
  const [isDeleteLoading, setIsDeleteLoading] = useState(false);
  const [dateErrorShown, setDateErrorShown] = useState(false);

  // ===== Formik for Filter =====
  const filterFormik = useFormik<FinanceTableFilterValues>({
    initialValues: {
      search: searchValue,
      transaction_types: '',
      bank_ids: '',
      customer_ids: '',
      supplier_ids: '',
      sort_by: '',
      start_date: '',
      end_date: '',
    },
    validationSchema: FinanceTableFilterSchema,
    enableReinitialize: true,
    onSubmit: (values) => {
      updateFilter('search', values.search);
      setSearchValue(values.search);
      updateFilter('transactionTypes', values.transaction_types);
      updateFilter('bankIds', values.bank_ids);
      updateFilter('customerIds', values.customer_ids);
      updateFilter('supplierIds', values.supplier_ids);
      updateFilter('sortBy', values.sort_by);
      updateFilter('startDate', values.start_date);
      updateFilter('endDate', values.end_date);
    },
  });

  // ===== Fetch Data =====
  const {
    data: finances,
    isLoading,
    mutate: refreshFinances,
  } = useSWR(
    `${FinanceApi.basePath}/transactions${getTableFilterQueryString()}`,
    FinanceApi.getAllFetcher
  );

  const {
    options: customerOptions,
    isLoadingOptions: customerIsLoadingOptions,
    setInputValue: customerInputValue,
    loadMore: customerLoadMore,
  } = useSelect(CustomerApi.basePath, 'id', 'name');
  const {
    options: supplierOptions,
    isLoadingOptions: supplierIsLoadingOptions,
    setInputValue: supplierInputValue,
    loadMore: supplierLoadMore,
  } = useSelect(SupplierApi.basePath, 'id', 'name');
  const sortByOptions = useMemo(() => {
    return [
      { label: 'Tanggal Pembayaran', value: 'payment_date' },
      { label: 'Tanggal Dibuat', value: 'created_at' },
    ];
  }, []);
  const {
    options: bankOptions,
    rawData: bankRawData,
    setInputValue: bankInputValue,
    loadMore: bankLoadMore,
  } = useSelect<Bank>(BankApi.basePath, 'id', 'alias');

  const bankSelectOptions = useMemo(() => {
    if (!isResponseSuccess(bankRawData)) return [];

    return bankOptions.map((bank) => {
      const bankData = bankRawData.data.find((data) => data.id === bank?.value);
      return {
        label: bankData
          ? `${bankData.alias} - ${bankData.account_number} - ${bankData.owner}`
          : '',
        value: bank?.value,
      };
    });
  }, [bankOptions, bankRawData]);

  // ===== Handler =====
  const searchChangeHandler = (e: React.ChangeEvent<HTMLInputElement>) => {
    filterFormik.setFieldValue('search', e.target.value);
  };
  const transactionTypeChangeHandler = (
    val: OptionType | OptionType[] | null
  ) => {
    setSelectedTransactionType(val);
    filterFormik.setFieldValue(
      'transaction_types',
      val
        ? Array.isArray(val)
          ? val.map((item) => item.value).join(',')
          : (val.value as string)
        : ''
    );
  };
  const bankChangeHandler = (val: OptionType | OptionType[] | null) => {
    setSelectedBank(val);
    filterFormik.setFieldValue(
      'bank_ids',
      val
        ? Array.isArray(val)
          ? val.map((item) => item.value).join(',')
          : (val.value as string)
        : ''
    );
  };
  const customerIdChangeHandler = (val: OptionType | OptionType[] | null) => {
    setSelectedCustomerId(val);
    filterFormik.setFieldValue(
      'customer_ids',
      val
        ? Array.isArray(val)
          ? val.map((item) => item.value).join(',')
          : (val.value as string)
        : ''
    );
  };
  const supplierIdChangeHandler = (val: OptionType | OptionType[] | null) => {
    setSelectedSupplierId(val);
    filterFormik.setFieldValue(
      'supplier_ids',
      val
        ? Array.isArray(val)
          ? val.map((item) => item.value).join(',')
          : (val.value as string)
        : ''
    );
  };
  const sortByChangeHandler = (val: OptionType | OptionType[] | null) => {
    setSelectedSortBy(val as OptionType);
    filterFormik.setFieldValue(
      'sort_by',
      val ? ((val as OptionType).value as string) : ''
    );
  };

  const startDateChangeHandler = (e: React.ChangeEvent<HTMLInputElement>) => {
    const value = e.target.value;
    const endDate = filterFormik.values.end_date;

    filterFormik.setFieldValue('start_date', value);

    if (value && endDate) {
      const startDate = new Date(value);
      const endDateObj = new Date(endDate);

      if (endDateObj < startDate) {
        filterFormik.setFieldError(
          'end_date',
          'Tanggal akhir tidak boleh masa lampau'
        );
        if (!dateErrorShown) {
          toast.error('Tanggal akhir tidak boleh masa lampau', {
            duration: Infinity,
          });
          setDateErrorShown(true);
        }
      } else {
        filterFormik.setFieldError('end_date', undefined);
        if (dateErrorShown) {
          toast.dismiss();
          setDateErrorShown(false);
        }
      }
    }
  };

  const endDateChangeHandler = (e: React.ChangeEvent<HTMLInputElement>) => {
    const value = e.target.value;
    const startDate = filterFormik.values.start_date;

    filterFormik.setFieldValue('end_date', value);

    if (value && startDate) {
      const startDateObj = new Date(startDate);
      const endDate = new Date(value);

      if (endDate < startDateObj) {
        filterFormik.setFieldError(
          'end_date',
          'Tanggal akhir tidak boleh masa lampau'
        );
        if (!dateErrorShown) {
          toast.error('Tanggal akhir tidak boleh masa lampau', {
            duration: Infinity,
          });
          setDateErrorShown(true);
        }
        return;
      }
    }

    filterFormik.setFieldError('end_date', undefined);
    if (dateErrorShown) {
      toast.dismiss();
      setDateErrorShown(false);
    }
  };

  const resetFilterHandler = () => {
    setSelectedTransactionType(null);
    setSelectedBank(null);
    setSelectedCustomerId(null);
    setSelectedSupplierId(null);
    setSelectedSortBy(null);

    filterFormik.resetForm();

    updateFilter('search', '');
    resetSearchValue();
    updateFilter('transactionTypes', '');
    updateFilter('bankIds', '');
    updateFilter('customerIds', '');
    updateFilter('supplierIds', '');
    updateFilter('sortBy', '');
    updateFilter('startDate', '');
    updateFilter('endDate', '');
  };
  const confirmationModalDeleteClickHandler = async () => {
    setIsDeleteLoading(true);

    await FinanceApi.delete(selectedFinance?.id as number);
    refreshFinances();

    deleteModal.closeModal();
    toast.success('Successfully delete Finance!');
    setIsDeleteLoading(false);
  };

  const columns = useMemo(() => {
    return [
      {
        header: 'ID',
        accessorKey: 'payment_code',
      },
      {
        header: 'References Number',
        accessorKey: 'reference_number',
        cell: (props: CellContext<Finance, unknown>) => {
          const value = props.row.original.reference_number;
          return <span>{value ?? '-'}</span>;
        },
      },
      {
        header: 'Jenis Transaksi',
        accessorKey: 'transaction_type',
        cell: (props: CellContext<Finance, unknown>) => {
          const value = props.row.original.transaction_type
            .split('_')
            .join(' ');
          return <span>{formatTitleCase(value)}</span>;
        },
      },
      {
        header: 'Pihak',
        accessorFn: (finance: Finance) => finance.party?.name,
        cell: (props: CellContext<Finance, unknown>) => {
          if (props.row.original.party?.id) {
            return <span>{props.row.original.party?.name}</span>;
          }
          return <span>{'-'}</span>;
        },
      },
      {
        header: 'Tanggal',
        accessorFn: (finance: Finance) =>
          formatDate(finance.payment_date, 'DD MMM YYYY'),
      },
      {
        header: 'Metode Pembayaran',
        accessorKey: 'payment_method',
        cell: (props: CellContext<Finance, unknown>) => {
          const value = props.row.original.payment_method.split('_').join(' ');
          return <span>{formatTitleCase(value)}</span>;
        },
      },
      {
        header: 'Bank',
        accessorFn: (finance: Finance) =>
          finance.bank
            ? `${finance.bank?.alias} - ${finance.bank?.account_number} - ${finance.bank?.owner}`
            : '-',
      },
      {
        header: 'Pengeluaran (Rp)',
        accessorFn: (finance: Finance) =>
          formatCurrency(Math.abs(finance.expense_amount)),
      },
      {
        header: 'Pemasukan (Rp)',
        accessorFn: (finance: Finance) =>
          formatCurrency(Math.abs(finance.income_amount)),
      },
      {
        header: 'Aksi',
        cell: (props: CellContext<Finance, unknown>) => {
          const currentPageSize =
            props.table.getPaginationRowModel().rows.length;
          const currentPageRows = props.table.getPaginationRowModel().flatRows;
          const currentRowRelativeIndex =
            currentPageRows.findIndex((r) => r.id === props.row.id) + 1;

          const isLast2Rows = currentRowRelativeIndex > currentPageSize - 2;

          const deleteClickHandler = () => {
            setSelectedFinance(props.row.original);
            deleteModal.openModal();
          };

          return (
            <>
              {currentPageSize > 2 && (
                <RowDropdownOptions isLast2Rows={isLast2Rows}>
                  <RowOptionsMenu
                    type='dropdown'
                    props={props}
                    deleteClickHandler={deleteClickHandler}
                  />
                </RowDropdownOptions>
              )}

              {currentPageSize <= 2 && (
                <RowCollapseOptions>
                  <RowOptionsMenu
                    type='collapse'
                    props={props}
                    deleteClickHandler={deleteClickHandler}
                  />
                </RowCollapseOptions>
              )}
            </>
          );
        },
      },
    ];
  }, []);

  useEffect(() => {
    return () => {
      if (dateErrorShown) {
        toast.dismiss();
      }
    };
  }, [dateErrorShown]);

  useEffect(() => {
    previousPathRef.current = window.location.pathname;

    return () => {
      const currentPath = window.location.pathname;

      const isCurrentPathFinance = currentPath.includes('/finance');
      const isPreviousPathFinance =
        previousPathRef.current?.includes('/finance');

      if (isPreviousPathFinance && !isCurrentPathFinance) {
        resetSearchValue();
      }

      if (dateErrorShown) {
        toast.dismiss();
        setDateErrorShown(false);
      }
    };
  }, [resetSearchValue, dateErrorShown]);

  return (
    <section className='size-full flex flex-col gap-6'>
      <div className='flex justify-end gap-2'>
        <RequirePermission permissions='lti.finance.injections.create'>
          <Button
            color='warning'
            className='min-w-24'
            href='/finance/add/injection'
          >
            Injection Saldo Bank
          </Button>
        </RequirePermission>
        <RequirePermission permissions='lti.finance.initial_balances.create'>
          <Button
            color='info'
            className='text-white min-w-24'
            href='/finance/add/initial-balance'
          >
            Saldo Awal
          </Button>
        </RequirePermission>
        <RequirePermission permissions='lti.finance.payments.create'>
          <Button color='primary' className='min-w-24' href='/finance/add'>
            Tambah
          </Button>
        </RequirePermission>
      </div>
      <Card
        variant='bordered'
        className={{
          wrapper: 'w-full',
        }}
        footer={
          <div className='flex justify-end gap-2'>
            <Button
              color='warning'
              className='min-w-24'
              onClick={resetFilterHandler}
            >
              Reset
            </Button>
            <Button
              color='primary'
              className='min-w-24'
              onClick={() => filterFormik.handleSubmit()}
            >
              Cari
            </Button>
          </div>
        }
      >
        <div className='grid grid-cols-4 gap-6'>
          <SelectInput
            options={FINANCE_TRANSACTION_TYPE_OPTIONS}
            label='Jenis Transaksi'
            value={selectedTransactionType}
            onChange={transactionTypeChangeHandler}
            closeMenuOnSelect={false}
            isClearable
            isMulti
          />
          <SelectInput
            options={customerOptions}
            label={'Customer'}
            value={selectedCustomerId}
            onChange={customerIdChangeHandler}
            onInputChange={customerInputValue}
            onMenuScrollToBottom={customerLoadMore}
            isLoading={customerIsLoadingOptions}
            closeMenuOnSelect={false}
            isClearable
            isMulti
          />
          <SelectInput
            options={supplierOptions}
            label={'Supplier'}
            value={selectedSupplierId}
            onChange={supplierIdChangeHandler}
            onInputChange={supplierInputValue}
            onMenuScrollToBottom={supplierLoadMore}
            isLoading={supplierIsLoadingOptions}
            closeMenuOnSelect={false}
            isClearable
            isMulti
          />
          <SelectInput
            options={bankSelectOptions}
            label='Bank'
            value={selectedBank}
            onChange={bankChangeHandler}
            onInputChange={bankInputValue}
            onMenuScrollToBottom={bankLoadMore}
            closeMenuOnSelect={false}
            isClearable
            isMulti
          />
          <SelectInput
            options={sortByOptions}
            label='Urutkan Berdasarkan'
            value={selectedSortBy}
            onChange={sortByChangeHandler}
            isClearable
          />
          <DateInput
            name='start_date'
            label='Periode Tanggal (Mulai)'
            value={filterFormik.values.start_date}
            onChange={startDateChangeHandler}
            errorMessage={
              filterFormik.errors.end_date
                ? filterFormik.errors.end_date
                : undefined
            }
          />
          <DateInput
            name='end_date'
            label='Periode Tanggal (Akhir)'
            value={filterFormik.values.end_date}
            onChange={endDateChangeHandler}
            errorMessage={
              filterFormik.errors.end_date
                ? filterFormik.errors.end_date
                : undefined
            }
          />
          <DebouncedTextInput
            name='search'
            label='Cari'
            placeholder='Cari'
            value={filterFormik.values.search}
            onChange={searchChangeHandler}
          />
        </div>
      </Card>
      <Table<Finance>
        data={isResponseSuccess(finances) ? finances.data : []}
        columns={columns}
        pageSize={tableFilterState.pageSize}
        page={tableFilterState.page}
        onPageChange={setPage}
        onPageSizeChange={setPageSize}
        totalItems={
          isResponseSuccess(finances) ? finances.meta?.total_results : 0
        }
        isLoading={isLoading}
      />
      <ConfirmationModal
        ref={deleteModal.ref}
        type='error'
        text={`Apakah anda yakin ingin menghapus data Finance ini (${selectedFinance?.payment_code})?`}
        secondaryButton={{
          text: 'Tidak',
        }}
        primaryButton={{
          text: 'Ya',
          color: 'error',
          isLoading: isDeleteLoading,
          onClick: confirmationModalDeleteClickHandler,
        }}
      />
    </section>
  );
};

export default FinanceTable;
